include "semaphore_utils.iol"
include "../AbstractActivity.iol"

type OpType:void {
  .msgID:string
  .content?:undefined
}

type CoordType:void {
  .rolesNum:int
  .hasAck?:bool
  .sid:string
}

type JoinType:void {
  .sid:string
}

interface MHInterface {
OneWay:
  initStartProcedure( CoordType )
RequestResponse:
  get_log( OpType )( undefined ), log( OpType )( undefined ), joinAck( JoinType )( void ), joinStart( JoinType )( void )
}

outputPort MH {
Interfaces: MHInterface
}

embedded {
Jolie : "__activity_manager/activities/988e3ebb-f82d-4abc-9fb1-60a74783d1a4/mh.ol" in MH
}

outputPort Leader {
Protocol: sodep
RequestResponse:
  joinAck( JoinType )( void ), joinStart( JoinType )( void )
}

outputPort Port0 {
Location: "socket://localhost:8002"
Protocol: jsonrpc
RequestResponse:
  log( undefined )( undefined )
}

outputPort Port1 {
Location: "socket://localhost:8003"
Protocol: jsonrpc
RequestResponse:
  getTime( undefined )( undefined )
}

inputPort MyInputPort {
Location: "local"
Protocol: sodep
Interfaces: AdaptActivityInterface
Aggregates: MH
}


define onRun
{
  var264.msgID = "2afa5718-1e90-4e12-8db3-9ecabc2f2486";
  get_log@MH( var264 )( var264 );
  var265 = var264.content;
  var266.value = var265;
  var266 = "entry";
  set@State( var266 )(  );
  {
    getTime@Port1( var267 )( var268 );
    var269.value = var268;
    var269 = "time";
    set@State( var269 )(  );
    get@State( "entry" )( var270 );
    get@State( "time" )( var271 );
    var272.p[0] = var271 + ": " + var270;
    log@Port0( var272 )( var273 );
    var274.value = var273;
    var274 = "_";
    set@State( var274 )(  )
  }
}

define start
{
  nullProcess
}

