include "semaphore_utils.iol"
include "../AbstractActivity.iol"

type OpType:void {
  .msgID:string
  .content?:undefined
}

type CoordType:void {
  .rolesNum:int
  .hasAck?:bool
  .sid:string
}

type JoinType:void {
  .sid:string
}

interface MHInterface {
OneWay:
  initStartProcedure( CoordType )
RequestResponse:
  response( OpType )( undefined ), joinAck( JoinType )( void ), joinStart( JoinType )( void ), get_response( OpType )( undefined )
}

outputPort MH {
Interfaces: MHInterface
}

embedded {
Jolie : "__activity_manager/activities/8c0b55df-8599-4ce5-8b80-1736a4e5b8fb/mh.ol" in MH
}

outputPort Leader {
Protocol: sodep
RequestResponse:
  joinAck( JoinType )( void ), joinStart( JoinType )( void )
}

inputPort MyInputPort {
Location: "local"
Protocol: sodep
Interfaces: AdaptActivityInterface
Aggregates: MH
}


define onRun
{
  {
    var275.msgID = "804bdcc1-a80e-4ddb-b636-786956868008";
    get_response@MH( var275 )( var275 );
    var276 = var275.content;
    var277.value = var276;
    var277 = "result";
    set@State( var277 )(  )
  }
}

define start
{
  nullProcess
}

