include "semaphore_utils.iol"
include "../AbstractActivity.iol"

type OpType:void {
  .msgID:string
  .content?:undefined
}

type CoordType:void {
  .rolesNum:int
  .hasAck?:bool
  .sid:string
}

type JoinType:void {
  .sid:string
}

interface MHInterface {
OneWay:
  initStartProcedure( CoordType )
RequestResponse:
  joinAck( JoinType )( void ), joinStart( JoinType )( void )
}

outputPort MH {
Interfaces: MHInterface
}

embedded {
Jolie : "__activity_manager/activities/bd13e47a-8cfb-4ba2-9851-1af43abf7376/mh.ol" in MH
}

outputPort Leader {
Protocol: sodep
OneWay:
  initStartProcedure( CoordType )
RequestResponse:
  joinAck( JoinType )( void ), joinStart( JoinType )( void )
}

outputPort LedRole {
Protocol: sodep
Interfaces: AdaptActivityInterface
RequestResponse:
  coord( OpType )( void )
}

outputPort client {
Location: "socket://localhost:10500/!/Activity/bd13e47a-8cfb-4ba2-9851-1af43abf7376"
Protocol: sodep
Interfaces: AdaptActivityInterface
RequestResponse:
  response( OpType )( undefined )
}

inputPort MyInputPort {
Location: "local"
Protocol: sodep
Aggregates: MH
}


define onRun
{
  onRunSR.name = "execute";
  release@SemaphoreUtils( onRunSR )(  );
  onRunSR.name = "done";
  acquire@SemaphoreUtils( onRunSR )(  )
}

define start
{
  var292.sid = "bd13e47a-8cfb-4ba2-9851-1af43abf7376";
  var292.rolesNum = 2;
  var292.hasAck = true;
  Leader.location = "socket://localhost:10501/";
  initStartProcedure@Leader( var292 );
  undef( var292.rolesNum );
  undef( var292.hasAck );
  startSR.name = "execute";
  acquire@SemaphoreUtils( startSR )(  );
  joinStart@Leader( var292 )(  );
  aReq.client = "socket://localhost:10501/";
  aReq.ports.seller.address = "socket://localhost:10501/";
  aReq.ports.client.address = "socket://localhost:10500/";
  checkForUpdate@AdaptationManager( aReq )( aRes );
  if ( is_defined( aRes ) ) {
    for (   c = 0, c < #aRes.roles.seller.code, c++ ){
      embed_scope@ActivityManager( aRes.roles.seller.code[ c ] )(  )
    };
    var291.sid =     adaptRequest.main_key = aRes.main_key;
    foreach ( r : aRes.roles ){
      var291.rolesNum++
    };
    var291.hasAck = true;
    initStartProcedure@Leader( var291 );
    var291.sid = "bd13e47a-8cfb-4ba2-9851-1af43abf7376_adapt";
    undef( var291.hasAck );
    initStartProcedure@Leader( var291 );
    undef( var291.rolesNum );
    undef( aRes.roles.seller );
    foreach ( roleName : aRes.roles ){
      if ( is_defined( aRes.roles.( roleName ).cookie ) ) {
        adaptRequest.cookie = aRes.roles.( roleName ).cookie;
        LedRole.location = aRes.roles.( roleName ).location;
        op6.msgID = adaptRequest.cookie;
        op6.content.sid = "bd13e47a-8cfb-4ba2-9851-1af43abf7376_adapt";
        op6.content.leader = Leader.location;
        coord@LedRole( op6 )(  )
      } else {
        adaptRequest.cookie = "bd13e47a-8cfb-4ba2-9851-1af43abf7376";
        LedRole.location = aRes.roles.( roleName ).location + "!/Activity/bd13e47a-8cfb-4ba2-9851-1af43abf7376"
      };
      adaptRequest.code << aRes.roles.( roleName ).code;
      adapt@LedRole( adaptRequest )(  );
      undef( adaptRequest.code )
    };
    joinStart@Leader( var291 )(  );
    run@ActivityManager( aRes.main_key )(  )
  } else {
    eReq.cookie = "bd13e47a-8cfb-4ba2-9851-1af43abf7376";
    noAdapt@client( eReq );
    var287 = "XXX";
    var288.value = var287;
    var288 = "result";
    set@State( var288 )(  );
    get@State( "result" )( var290 );
    _tmp = var290;
    var289.content = _tmp;
    var289.msgID = "2aa5054f-1a56-4b45-aa99-0cb869b73be4";
    response@client( var289 )(  )
  };
  var293.sid = "bd13e47a-8cfb-4ba2-9851-1af43abf7376";
  joinAck@Leader( var293 )(  );
  startActivity@ActivityManager( "bd13e47a-8cfb-4ba2-9851-1af43abf7376" );
  startSR.name = "done";
  release@SemaphoreUtils( startSR )(  )
}

